#include "../inc/sctl.h"
#include "../inc/err.h"

void
packps(Buf *b, Ps *p)
{
	u64 i, j;
	Proc *pr;
	Thread *th;

	bufpushu64(b, p->npr);
	for(i = 0; i < p->npr; i++){
		pr = &p->pr[i];
		bufpushu64(b, pr->pid);
		bufpushs(b, pr->cmd);
		bufpushu64(b, pr->nth);
		for(j = 0; j < pr->nth; j++){
			th = &pr->th[j];
			bufpushu64(b, th->tid);
		}
	}
}

void
freeps(Ps *p)
{
	u64 i;
	for(i = 0; i < p->npr; i++){
		free(p->pr[i].cmd);
		free(p->pr[i].th);
	}
	free(p->pr);
	free(p);
}

Ps*
ps(char **err)
{
	Ps *p;

	p = xmalloc(sizeof(Ps));
	return p;
}
