#ifdef SCTL_WIN
#include "../win/sys.h"
#endif
#ifdef SCTL_LINUX
#include "../linux/sys.h"
#endif
#ifdef SCTL_FREEBSD
#include "../freebsd/sys.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stddef.h>
#include <ctype.h>
#include <string.h>
#include <time.h>

/* plan 9 command line argument processing */
extern char	*argv0;
#define	ARGBEGIN	for((argv0?0:(argv0=*argv)),argv++,argc--;\
			    argv[0] && argv[0][0]=='-' && argv[0][1];\
			    argc--, argv++) {\
				char *_args, *_argt;\
				char _argc;\
				_args = &argv[0][1];\
				if(_args[0]=='-' && _args[1]==0){\
					argc--; argv++; break;\
				}\
				_argc = 0;\
				while(*_args && (_argc=*_args++))\
				switch(_argc)

#define	ARGEND		SET(_argt);USED(_argt);USED(_argc);USED(_args);}USED(argv);USED(argc);
#define ARGOPT()	(_argt=_args, _args=(char*)"", *_argt?_argt:nil)
#define	ARGF()		(_argt=_args, _args=(char*)"",\
				(*_argt? _argt: argv[1]? (argc--, *++argv): 0))
#define	EARGF(x)	(_argt=_args, _args=(char*)"",\
				(*_argt? _argt: argv[1]? (argc--, *++argv): ((x), abort(), (char*)0)))

#define	ARGC()		_argc
#define	SET(x)	((x)=0)
#define	USED(x)	if(x){}else{}
