#include "dwarf.h"

char *dwarfattrname[] = {
	[DW_AT_sibling] = "sibling",
	[DW_AT_location] = "location",
	[DW_AT_name] = "name",
	[DW_AT_ordering] = "ordering",
	[DW_AT_subscr_data] = "subscr_data",
	[DW_AT_byte_size] = "byte_size",
	[DW_AT_bit_offset] = "bit_offset",
	[DW_AT_bit_size] = "bit_size",
	[DW_AT_element_list] = "element_list",
	[DW_AT_stmt_list] = "stmt_list",
	[DW_AT_low_pc] = "low_pc",
	[DW_AT_high_pc] = "high_pc",
	[DW_AT_language] = "language",
	[DW_AT_member] = "member",
	[DW_AT_discr] = "discr",
	[DW_AT_discr_value] = "discr_value",
	[DW_AT_visibility] = "visibility",
	[DW_AT_import] = "import",
	[DW_AT_string_length] = "string_length",
	[DW_AT_common_reference] = "common_reference",
	[DW_AT_comp_dir] = "comp_dir",
	[DW_AT_const_value] = "const_value",
	[DW_AT_containing_type] = "containing_type",
	[DW_AT_default_value] = "default_value",
	[DW_AT_inline] = "inline",
	[DW_AT_is_optional] = "is_optional",
	[DW_AT_lower_bound] = "lower_bound",
	[DW_AT_producer] = "producer",
	[DW_AT_prototyped] = "prototyped",
	[DW_AT_return_addr] = "return_addr",
	[DW_AT_start_scope] = "start_scope",
	[DW_AT_bit_stride] = "bit_stride",
	[DW_AT_stride_size] = "stride_size",
	[DW_AT_upper_bound] = "upper_bound",
	[DW_AT_abstract_origin] = "abstract_origin",
	[DW_AT_accessibility] = "accessibility",
	[DW_AT_address_class] = "address_class",
	[DW_AT_artificial] = "artificial",
	[DW_AT_base_types] = "base_types",
	[DW_AT_calling_convention] = "calling_convention",
	[DW_AT_count] = "count",
	[DW_AT_data_member_location] = "data_member_location",
	[DW_AT_decl_column] = "decl_column",
	[DW_AT_decl_file] = "decl_file",
	[DW_AT_decl_line] = "decl_line",
	[DW_AT_declaration] = "declaration",
	[DW_AT_discr_list] = "discr_list",
	[DW_AT_encoding] = "encoding",
	[DW_AT_external] = "external",
	[DW_AT_frame_base] = "frame_base",
	[DW_AT_friend] = "friend",
	[DW_AT_identifier_case] = "identifier_case",
	[DW_AT_macro_info] = "macro_info",
	[DW_AT_namelist_item] = "namelist_item",
	[DW_AT_priority] = "priority",
	[DW_AT_segment] = "segment",
	[DW_AT_specification] = "specification",
	[DW_AT_static_link] = "static_link",
	[DW_AT_type] = "type",
	[DW_AT_use_location] = "use_location",
	[DW_AT_variable_parameter] = "variable_parameter",
	[DW_AT_virtuality] = "virtuality",
	[DW_AT_vtable_elem_location] = "vtable_elem_location",
	[DW_AT_allocated] = "allocated",
	[DW_AT_associated] = "associated",
	[DW_AT_data_location] = "data_location",
	[DW_AT_byte_stride] = "byte_stride",
	[DW_AT_stride] = "stride",
	[DW_AT_entry_pc] = "entry_pc",
	[DW_AT_use_UTF8] = "use_UTF8",
	[DW_AT_extension] = "extension",
	[DW_AT_ranges] = "ranges",
	[DW_AT_trampoline] = "trampoline",
	[DW_AT_call_column] = "call_column",
	[DW_AT_call_file] = "call_file",
	[DW_AT_call_line] = "call_line",
	[DW_AT_description] = "description",
	[DW_AT_binary_scale] = "binary_scale",
	[DW_AT_decimal_scale] = "decimal_scale",
	[DW_AT_small] = "small",
	[DW_AT_decimal_sign] = "decimal_sign",
	[DW_AT_digit_count] = "digit_count",
	[DW_AT_picture_string] = "picture_string",
	[DW_AT_mutable] = "mutable",
	[DW_AT_threads_scaled] = "threads_scaled",
	[DW_AT_explicit] = "explicit",
	[DW_AT_object_pointer] = "object_pointer",
	[DW_AT_endianity] = "endianity",
	[DW_AT_elemental] = "elemental",
	[DW_AT_pure] = "pure",
	[DW_AT_recursive] = "recursive",
	[DW_AT_HP_block_index] = "HP_block_index",
	[DW_AT_lo_user] = "lo_user",
	[DW_AT_MIPS_fde] = "MIPS_fde",
	[DW_AT_MIPS_loop_begin] = "MIPS_loop_begin",
	[DW_AT_MIPS_tail_loop_begin] = "MIPS_tail_loop_begin",
	[DW_AT_MIPS_epilog_begin] = "MIPS_epilog_begin",
	[DW_AT_MIPS_loop_unroll_factor] = "MIPS_loop_unroll_factor",
	[DW_AT_MIPS_software_pipeline_depth] = "MIPS_software_pipeline_depth",
	[DW_AT_MIPS_linkage_name] = "MIPS_linkage_name",
	[DW_AT_MIPS_stride] = "MIPS_stride",
	[DW_AT_MIPS_abstract_name] = "MIPS_abstract_name",
	[DW_AT_MIPS_clone_origin] = "MIPS_clone_origin",
	[DW_AT_MIPS_has_inlines] = "MIPS_has_inlines",
	[DW_AT_MIPS_stride_byte] = "MIPS_stride_byte",
	[DW_AT_MIPS_stride_elem] = "MIPS_stride_elem",
	[DW_AT_MIPS_ptr_dopetype] = "MIPS_ptr_dopetype",
	[DW_AT_MIPS_allocatable_dopetype] = "MIPS_allocatable_dopetype",
	[DW_AT_MIPS_assumed_shape_dopetype] = "MIPS_assumed_shape_dopetype",
	[DW_AT_MIPS_assumed_size] = "MIPS_assumed_size",
	[DW_AT_HP_unmodifiable] = "HP_unmodifiable",
	[DW_AT_HP_actuals_stmt_list] = "HP_actuals_stmt_list",
	[DW_AT_HP_proc_per_section] = "HP_proc_per_section",
	[DW_AT_HP_raw_data_ptr] = "HP_raw_data_ptr",
	[DW_AT_HP_pass_by_reference] = "HP_pass_by_reference",
	[DW_AT_HP_opt_level] = "HP_opt_level",
	[DW_AT_HP_prof_version_id] = "HP_prof_version_id",
	[DW_AT_HP_opt_flags] = "HP_opt_flags",
	[DW_AT_HP_cold_region_low_pc] = "HP_cold_region_low_pc",
	[DW_AT_HP_cold_region_high_pc] = "HP_cold_region_high_pc",
	[DW_AT_HP_all_variables_modifiable] = "HP_all_variables_modifiable",
	[DW_AT_HP_linkage_name] = "HP_linkage_name",
	[DW_AT_HP_prof_flags] = "HP_prof_flags",
	[DW_AT_sf_names] = "sf_names",
	[DW_AT_src_info] = "src_info",
	[DW_AT_mac_info] = "mac_info",
	[DW_AT_src_coords] = "src_coords",
	[DW_AT_body_begin] = "body_begin",
	[DW_AT_body_end] = "body_end",
	[DW_AT_GNU_vector] = "GNU_vector",
	[DW_AT_VMS_rtnbeg_pd_address] = "VMS_rtnbeg_pd_address",
	[DW_AT_ALTIUM_loclist] = "ALTIUM_loclist",
	[DW_AT_PGI_lbase] = "PGI_lbase",
	[DW_AT_PGI_soffset] = "PGI_soffset",
	[DW_AT_PGI_lstride] = "PGI_lstride",
	[DW_AT_upc_threads_scaled] = "upc_threads_scaled",
	[DW_AT_hi_user] = "hi_user",
};

char *dwarftagname[] = {
	[DW_TAG_array_type] = "array_type",
	[DW_TAG_class_type] = "class_type",
	[DW_TAG_entry_point] = "entry_point",
	[DW_TAG_enumeration_type] = "enumeration_type",
	[DW_TAG_formal_parameter] = "formal_parameter",
	[DW_TAG_imported_declaration] = "imported_declaration",
	[DW_TAG_label] = "label",
	[DW_TAG_lexical_block] = "lexical_block",
	[DW_TAG_member] = "member",
	[DW_TAG_pointer_type] = "pointer_type",
	[DW_TAG_reference_type] = "reference_type",
	[DW_TAG_compile_unit] = "compile_unit",
	[DW_TAG_string_type] = "string_type",
	[DW_TAG_structure_type] = "structure_type",
	[DW_TAG_subroutine_type] = "subroutine_type",
	[DW_TAG_typedef] = "typedef",
	[DW_TAG_union_type] = "union_type",
	[DW_TAG_unspecified_parameters] = "unspecified_parameters",
	[DW_TAG_variant] = "variant",
	[DW_TAG_common_block] = "common_block",
	[DW_TAG_common_inclusion] = "common_inclusion",
	[DW_TAG_inheritance] = "inheritance",
	[DW_TAG_inlined_subroutine] = "inlined_subroutine",
	[DW_TAG_module] = "module",
	[DW_TAG_ptr_to_member_type] = "ptr_to_member_type",
	[DW_TAG_set_type] = "set_type",
	[DW_TAG_subrange_type] = "subrange_type",
	[DW_TAG_with_stmt] = "with_stmt",
	[DW_TAG_access_declaration] = "access_declaration",
	[DW_TAG_base_type] = "base_type",
	[DW_TAG_catch_block] = "catch_block",
	[DW_TAG_const_type] = "const_type",
	[DW_TAG_constant] = "constant",
	[DW_TAG_enumerator] = "enumerator",
	[DW_TAG_file_type] = "file_type",
	[DW_TAG_friend] = "friend",
	[DW_TAG_namelist] = "namelist",
	[DW_TAG_namelist_item] = "namelist_item",
	[DW_TAG_namelist_items] = "namelist_items",
	[DW_TAG_packed_type] = "packed_type",
	[DW_TAG_subprogram] = "subprogram",
	[DW_TAG_template_type_parameter] = "template_type_parameter",
	[DW_TAG_template_type_param] = "template_type_param",
	[DW_TAG_template_value_parameter] = "template_value_parameter",
	[DW_TAG_template_value_param] = "template_value_param",
	[DW_TAG_thrown_type] = "thrown_type",
	[DW_TAG_try_block] = "try_block",
	[DW_TAG_variant_part] = "variant_part",
	[DW_TAG_variable] = "variable",
	[DW_TAG_volatile_type] = "volatile_type",
	[DW_TAG_dwarf_procedure] = "dwarf_procedure",
	[DW_TAG_restrict_type] = "restrict_type",
	[DW_TAG_interface_type] = "interface_type",
	[DW_TAG_namespace] = "namespace",
	[DW_TAG_imported_module] = "imported_module",
	[DW_TAG_unspecified_type] = "unspecified_type",
	[DW_TAG_partial_unit] = "partial_unit",
	[DW_TAG_imported_unit] = "imported_unit",
	[DW_TAG_mutable_type] = "mutable_type",
	[DW_TAG_condition] = "condition",
	[DW_TAG_shared_type] = "shared_type",
	[DW_TAG_lo_user] = "lo_user",
	[DW_TAG_MIPS_loop] = "MIPS_loop",
	[DW_TAG_HP_array_descriptor] = "HP_array_descriptor",
	[DW_TAG_format_label] = "format_label",
	[DW_TAG_function_template] = "function_template",
	[DW_TAG_class_template] = "class_template",
	[DW_TAG_GNU_BINCL] = "GNU_BINCL",
	[DW_TAG_GNU_EINCL] = "GNU_EINCL",
	[DW_TAG_ALTIUM_circ_type] = "ALTIUM_circ_type",
	[DW_TAG_ALTIUM_mwa_circ_type] = "ALTIUM_mwa_circ_type",
	[DW_TAG_ALTIUM_rev_carry_type] = "ALTIUM_rev_carry_type",
	[DW_TAG_ALTIUM_rom] = "ALTIUM_rom",
	[DW_TAG_upc_shared_type] = "upc_shared_type",
	[DW_TAG_upc_strict_type] = "upc_strict_type",
	[DW_TAG_upc_relaxed_type] = "upc_relaxed_type",
	[DW_TAG_PGI_kanji_type] = "PGI_kanji_type",
	[DW_TAG_PGI_interface_block] = "PGI_interface_block",
	[DW_TAG_hi_user] = "hi_user",
};

char *dwarfopname[] = {
	[DW_OP_addr] = "addr",
	[DW_OP_deref] = "deref",
	[DW_OP_const1u] = "const1u",
	[DW_OP_const1s] = "const1s",
	[DW_OP_const2u] = "const2u",
	[DW_OP_const2s] = "const2s",
	[DW_OP_const4u] = "const4u",
	[DW_OP_const4s] = "const4s",
	[DW_OP_const8u] = "const8u",
	[DW_OP_const8s] = "const8s",
	[DW_OP_constu] = "constu",
	[DW_OP_consts] = "consts",
	[DW_OP_dup] = "dup",
	[DW_OP_drop] = "drop",
	[DW_OP_over] = "over",
	[DW_OP_pick] = "pick",
	[DW_OP_swap] = "swap",
	[DW_OP_rot] = "rot",
	[DW_OP_xderef] = "xderef",
	[DW_OP_abs] = "abs",
	[DW_OP_and] = "and",
	[DW_OP_div] = "div",
	[DW_OP_minus] = "minus",
	[DW_OP_mod] = "mod",
	[DW_OP_mul] = "mul",
	[DW_OP_neg] = "neg",
	[DW_OP_not] = "not",
	[DW_OP_or] = "or",
	[DW_OP_plus] = "plus",
	[DW_OP_plus_uconst] = "plus_uconst",
	[DW_OP_shl] = "shl",
	[DW_OP_shr] = "shr",
	[DW_OP_shra] = "shra",
	[DW_OP_xor] = "xor",
	[DW_OP_bra] = "bra",
	[DW_OP_eq] = "eq",
	[DW_OP_ge] = "ge",
	[DW_OP_gt] = "gt",
	[DW_OP_le] = "le",
	[DW_OP_lt] = "lt",
	[DW_OP_ne] = "ne",
	[DW_OP_skip] = "skip",
	[DW_OP_lit0] = "lit0",
	[DW_OP_lit1] = "lit1",
	[DW_OP_lit2] = "lit2",
	[DW_OP_lit3] = "lit3",
	[DW_OP_lit4] = "lit4",
	[DW_OP_lit5] = "lit5",
	[DW_OP_lit6] = "lit6",
	[DW_OP_lit7] = "lit7",
	[DW_OP_lit8] = "lit8",
	[DW_OP_lit9] = "lit9",
	[DW_OP_lit10] = "lit10",
	[DW_OP_lit11] = "lit11",
	[DW_OP_lit12] = "lit12",
	[DW_OP_lit13] = "lit13",
	[DW_OP_lit14] = "lit14",
	[DW_OP_lit15] = "lit15",
	[DW_OP_lit16] = "lit16",
	[DW_OP_lit17] = "lit17",
	[DW_OP_lit18] = "lit18",
	[DW_OP_lit19] = "lit19",
	[DW_OP_lit20] = "lit20",
	[DW_OP_lit21] = "lit21",
	[DW_OP_lit22] = "lit22",
	[DW_OP_lit23] = "lit23",
	[DW_OP_lit24] = "lit24",
	[DW_OP_lit25] = "lit25",
	[DW_OP_lit26] = "lit26",
	[DW_OP_lit27] = "lit27",
	[DW_OP_lit28] = "lit28",
	[DW_OP_lit29] = "lit29",
	[DW_OP_lit30] = "lit30",
	[DW_OP_lit31] = "lit31",
	[DW_OP_reg0] = "reg0",
	[DW_OP_reg1] = "reg1",
	[DW_OP_reg2] = "reg2",
	[DW_OP_reg3] = "reg3",
	[DW_OP_reg4] = "reg4",
	[DW_OP_reg5] = "reg5",
	[DW_OP_reg6] = "reg6",
	[DW_OP_reg7] = "reg7",
	[DW_OP_reg8] = "reg8",
	[DW_OP_reg9] = "reg9",
	[DW_OP_reg10] = "reg10",
	[DW_OP_reg11] = "reg11",
	[DW_OP_reg12] = "reg12",
	[DW_OP_reg13] = "reg13",
	[DW_OP_reg14] = "reg14",
	[DW_OP_reg15] = "reg15",
	[DW_OP_reg16] = "reg16",
	[DW_OP_reg17] = "reg17",
	[DW_OP_reg18] = "reg18",
	[DW_OP_reg19] = "reg19",
	[DW_OP_reg20] = "reg20",
	[DW_OP_reg21] = "reg21",
	[DW_OP_reg22] = "reg22",
	[DW_OP_reg23] = "reg23",
	[DW_OP_reg24] = "reg24",
	[DW_OP_reg25] = "reg25",
	[DW_OP_reg26] = "reg26",
	[DW_OP_reg27] = "reg27",
	[DW_OP_reg28] = "reg28",
	[DW_OP_reg29] = "reg29",
	[DW_OP_reg30] = "reg30",
	[DW_OP_reg31] = "reg31",
	[DW_OP_breg0] = "breg0",
	[DW_OP_breg1] = "breg1",
	[DW_OP_breg2] = "breg2",
	[DW_OP_breg3] = "breg3",
	[DW_OP_breg4] = "breg4",
	[DW_OP_breg5] = "breg5",
	[DW_OP_breg6] = "breg6",
	[DW_OP_breg7] = "breg7",
	[DW_OP_breg8] = "breg8",
	[DW_OP_breg9] = "breg9",
	[DW_OP_breg10] = "breg10",
	[DW_OP_breg11] = "breg11",
	[DW_OP_breg12] = "breg12",
	[DW_OP_breg13] = "breg13",
	[DW_OP_breg14] = "breg14",
	[DW_OP_breg15] = "breg15",
	[DW_OP_breg16] = "breg16",
	[DW_OP_breg17] = "breg17",
	[DW_OP_breg18] = "breg18",
	[DW_OP_breg19] = "breg19",
	[DW_OP_breg20] = "breg20",
	[DW_OP_breg21] = "breg21",
	[DW_OP_breg22] = "breg22",
	[DW_OP_breg23] = "breg23",
	[DW_OP_breg24] = "breg24",
	[DW_OP_breg25] = "breg25",
	[DW_OP_breg26] = "breg26",
	[DW_OP_breg27] = "breg27",
	[DW_OP_breg28] = "breg28",
	[DW_OP_breg29] = "breg29",
	[DW_OP_breg30] = "breg30",
	[DW_OP_breg31] = "breg31",
	[DW_OP_regx] = "regx",
	[DW_OP_fbreg] = "fbreg",
	[DW_OP_bregx] = "bregx",
	[DW_OP_piece] = "piece",
	[DW_OP_deref_size] = "deref_size",
	[DW_OP_xderef_size] = "xderef_size",
	[DW_OP_nop] = "nop",
	[DW_OP_push_object_address] = "push_object_address",
	[DW_OP_call2] = "call2",
	[DW_OP_call4] = "call4",
	[DW_OP_call_ref] = "call_ref",
	[DW_OP_form_tls_address] = "form_tls_address",
	[DW_OP_call_frame_cfa] = "call_frame_cfa",
	[DW_OP_bit_piece] = "bit_piece",
	[DW_OP_GNU_push_tls_address] = "GNU_push_tls_address",
	[DW_OP_lo_user] = "lo_user",
	[DW_OP_HP_unknown] = "HP_unknown",
	[DW_OP_HP_is_value] = "HP_is_value",
	[DW_OP_HP_fltconst4] = "HP_fltconst4",
	[DW_OP_HP_fltconst8] = "HP_fltconst8",
	[DW_OP_HP_mod_range] = "HP_mod_range",
	[DW_OP_HP_unmod_range] = "HP_unmod_range",
	[DW_OP_HP_tls] = "HP_tls",
	[DW_OP_hi_user] = "hi_user",
};

char *dwarfformname[] = {
	[DW_FORM_addr] =                    "addr",
	[DW_FORM_block2] =                  "block2",
	[DW_FORM_block4] =                  "block4",
	[DW_FORM_data2] =                   "data2",
	[DW_FORM_data4] =                   "data4",
	[DW_FORM_data8] =                   "data8",
	[DW_FORM_string] =                  "string",
	[DW_FORM_block] =                   "block",
	[DW_FORM_block1] =                  "block1",
	[DW_FORM_data1] =                   "data1",
	[DW_FORM_flag] =                    "flag",
	[DW_FORM_sdata] =                   "sdata",
	[DW_FORM_strp] =                    "strp",
	[DW_FORM_udata] =                   "udata",
	[DW_FORM_ref_addr] =                "ref_addr",
	[DW_FORM_ref1] =                    "ref1",
	[DW_FORM_ref2] =                    "ref2",
	[DW_FORM_ref4] =                    "ref4",
	[DW_FORM_ref8] =                    "ref8",
	[DW_FORM_ref_udata] =               "ref_udata",
	[DW_FORM_indirect] =                "indirect",
};

char *dwarfcfaname[] = {
	[DW_CFA_advance_loc] =		"DW_CFA_advance_loc",
	[DW_CFA_offset] =		"DW_CFA_offset",
	[DW_CFA_restore] =		"DW_CFA_restore",
	[DW_CFA_nop] =			"DW_CFA_nop",
	[DW_CFA_set_loc] =		"DW_CFA_set_loc",
	[DW_CFA_advance_loc1] =		"DW_CFA_advance_loc1",
	[DW_CFA_advance_loc2] =		"DW_CFA_advance_loc2",
	[DW_CFA_advance_loc4] =		"DW_CFA_advance_loc4",
	[DW_CFA_offset_extended] =	"DW_CFA_offset_extended",
	[DW_CFA_restore_extended] =	"DW_CFA_restore_extended",
	[DW_CFA_undefined] =		"DW_CFA_undefined",
	[DW_CFA_same_value] =		"DW_CFA_same_value",
	[DW_CFA_register] =		"DW_CFA_register",
	[DW_CFA_remember_state] =	"DW_CFA_remember_state",
	[DW_CFA_restore_state] =	"DW_CFA_restore_state",
	[DW_CFA_def_cfa] =		"DW_CFA_def_cfa",
	[DW_CFA_def_cfa_register] =	"DW_CFA_def_cfa_register",
	[DW_CFA_def_cfa_offset] =	"DW_CFA_def_cfa_offset",
	[DW_CFA_def_cfa_expression] =	"DW_CFA_def_cfa_expression",
	[DW_CFA_expression] =		"DW_CFA_expression",
	[DW_CFA_cfa_offset_extended_sf] ="DW_CFA_cfa_offset_extended_sf",
	[DW_CFA_def_cfa_sf] =		"DW_CFA_def_cfa_sf",
	[DW_CFA_def_cfa_offset_sf] =	"DW_CFA_def_cfa_offset_sf",
	[DW_CFA_val_offset] =		"DW_CFA_val_offset",
	[DW_CFA_val_offset_sf] =	"DW_CFA_val_offset_sf",
	[DW_CFA_val_expression] =	"DW_CFA_val_expression",
	[DW_CFA_lo_user] =		"DW_CFA_lo_user",
	[DW_CFA_MIPS_advance_loc8] =	"DW_CFA_MIPS_advance_loc8",
	[DW_CFA_GNU_window_save] =	"DW_CFA_GNU_window_save",
	[DW_CFA_GNU_args_size] =	"DW_CFA_GNU_args_size",
	[DW_CFA_GNU_negative_offset_extended] =
		"DW_CFA_GNU_negative_offset_extended",
	[DW_CFA_high_user] =		"DW_CFA_high_user",
};

char *dwarflnsname[] = {
	[DW_LNS_copy] = "DW_LNS_copy",
	[DW_LNS_advance_pc] = "DW_LNS_advance_pc",
	[DW_LNS_advance_line] = "DW_LNS_advance_line",
	[DW_LNS_set_file] = "DW_LNS_set_file",
	[DW_LNS_set_column] = "DW_LNS_set_column",
	[DW_LNS_negate_stmt] = "DW_LNS_negate_stmt",
	[DW_LNS_set_basic_block] = "DW_LNS_set_basic_block",
	[DW_LNS_const_add_pc] = "DW_LNS_const_add_pc",
	[DW_LNS_fixed_advance_pc] = "DW_LNS_fixed_advance_pc",
	[DW_LNS_set_prologue_end] = "DW_LNS_set_prologue_end",
	[DW_LNS_set_epilogue_begin] = "DW_LNS_set_epilogue_begin",
	[DW_LNS_set_isa] = "DW_LNS_set_isa",
	[DW_LNE_end_sequence] = "DW_LNE_end_sequence",
	[DW_LNE_set_address] = "DW_LNE_set_address",
	[DW_LNE_define_file] = "DW_LNE_define_file",
};
